/* TroiaPreview
 * version 0.4 date 2004-11-30
 * Copyright (C) 2003-2004 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_Globals
#define INC_Globals

#include "Tools.h"
#include "Vector.h"

//global constants
#define Pi 3.1415926535897932384626433832795
#define PixelX 104
#define PixelY 80
#define PixelZ 32
#define PixelSize 0.14
#define PosMinX 0.2
#define PosMaxX (PixelX * PixelSize - 0.2)
#define PosMinY 0.2
#define PosMaxY (PixelY * PixelSize - 0.2)
#define PosMinZ 0.2
#define PosMaxZ (PixelZ * PixelSize - 0.2)
#define FrontAngleMax (0.35 * Pi)
#define CenterX (0.5 * PixelX * PixelSize)
#define CenterY (0.5 * PixelY * PixelSize)
#define CenterZ (0.5 * PixelZ * PixelSize) 
#define CamptSpeedRange 10.0
#define MoveStep 0.2
#define TurnStep (Pi / 40.0)
#define MouseMoveStep 0.02
#define MouseTurnStep (Pi / 800.0)
#define TimeRange 86400.0

//global types
typedef struct _tCampt //a cam-point
{
  tVector Pos; //position of cam
  tVector Front; //front-direction of cam
} tCampt;

//global variables
extern tVector Pos, Front; //viewer-position and front-direction
extern int Back; //display background?
extern int AntiAlias; //use antialiasing?
extern int CamptsCnt; //list with cam-points
extern tCampt * pCampts;
extern double CamptSpeed; //cam-point-speed (in cam-points per second)
extern double CamptRefTime; //reference-time for cam-point-movement
extern int CamMoving; //if cam is moving or not
extern int Console;
extern int RequestEnd; //if end of program is requested

//repair current position and front direction
void RepairPosFront( );

#endif //#ifndef INC_Globals

